/* RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and that
no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net

Developed by: Scott Williamson
*/

#include "rwhois.h"
#ifdef ultrix
#include <sys/file.h>
#else
#include <fcntl.h>
#endif
extern int errno;
extern char *sys_errlist[];

contact( use_server)
struct SERVER *use_server;
{

	char *tmp;
	struct sockaddr_in	sin;
	struct hostent		*host;
	struct servent		*service;

	int ret = CONTGOOD;
	char temp[MAXBUFF];



		SERVERSTARTTIME;

		if( verbose )
		{
			printf("\nConnecting to [%s] port [%d] ", 
				use_server->server, use_server->port);

			switch(  use_server->reftype)
			{
				case REF_PRESET:
					printf(" -> client default server\n");
					break;
				case REF_CMDLINE:
					printf(" -> command line server\n");
					break;
				case REF_CONFFILE:
					printf(" -> config file server\n");
					break;
				case REF_REFERRAL:
					printf("following a referral\n");
					break;
				case REF_SEEALSO:
					printf("for additional information\n"); 
					break;
				case REF_PUNT:
					printf("Punt referral to higher authority\n"); 
					break;
				default:
					printf("Don't know why\n");
					break;
			}

			
		}

		if (!(host = gethostbyname (use_server->server)))
		{
			unsigned long	hostaddr;

			hostaddr = inet_addr (use_server->server);
			if (!(host = gethostbyaddr ( (char *)&hostaddr, 4, AF_INET)))
			{
				sprintf(temp, "Can't find host '%s'.",
					use_server->server);
				error( temp);
				++current_referral;
				ret = CONTBADADD;
			}

		}
		else
		{

			/* Create a socket  if ok continue on to contact server */

			if ((use_server->sh = socket( PF_INET, SOCK_STREAM, 0)) < 0)
			{
				tmp = safecalloc( 1, (strlen( cmdname) + 10)); 
				sprintf (tmp, "%s: socket",MAXBUFFER , cmdname);
				perror(tmp);
				++current_referral;
				free( tmp);
				ret = CONTBADSOCK;
			}
			else {

				/* Bind to that socket */
				sin.sin_family = host->h_addrtype;

				/* lookup the port number for the rwhois server */

#ifdef __STDC__
				memcpy (&sin.sin_addr,host->h_addr, host->h_length);
#else
				bcopy (host->h_addr, &sin.sin_addr, host->h_length);
#endif
				if(!use_server->port)
				{
					if ((service = getservbyname(SERVICE, PROTOCOL)) == NULL) {
						fprintf(stderr, "%s: Service unknown %s/%s is.\n",
							cmdname, SERVICE, PROTOCOL);
						fprintf(stderr, "Will try to use port %d\n", NORMPORT);
					}

					/* Connect to that port */
					if( service == NULL )
						sin.sin_port = htons(NORMPORT);
					else
						sin.sin_port = service->s_port;

				}
				else
					sin.sin_port = htons(use_server->port);


				if (connect (use_server->sh, (struct sockaddr *) &sin, 
					sizeof (sin)) < 0) 
				{
					tmp = safecalloc( 1, (strlen( cmdname) 
						+ strlen( use_server->server) + 20)); 
					sprintf (tmp, "%s: <%s> on connect : ", cmdname, 
							use_server->server);
					perror(tmp);
					free( tmp);
					ret = CONTBADCON;
				}
				else {

					SERVERCONTIME;

/* this is not really correct .... this is really a POSIX thing */
#ifdef __STDC__
					if((ret = fcntl( use_server->sh, F_SETFL, O_NONBLOCK)) < 0 )
#else
					if((ret = fcntl( use_server->sh, F_SETFL, O_NDELAY)) < 0 )
#endif
					{
						printf("Can't make socket non-blocking : %s\n",
							sys_errlist[errno]);
						ret = CONTBADMODE;
					}

				}
			}
		}

	return( ret);

}
