/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#define FAILED_PEERNAME 100 /* Get Peer Name Query Failed */
#define REGIST_DEFFERED 120 /* Registration Not Processed... Will Process Hours: */
#define NON_AUTH_ANSWER 130 /* Not Authority to Answer... TTL Good*/ */
#define REFERRED_SERVICE 200 /* Service Not Available.. Referral To Follow */
#define NO_RECORDS_FOUND 230 /* No Records Found */
#define NON_AUTH_MARTIAN 231 /* Not Authority to Answer.. TTL Expired */
#define UNAUTH_TO_CACHE  232 /* Cache Disabled */
#define UNCOMPAT_VERSION 300 /* Not Compatible With That Version Number */
#define INVALID_ATTRIBUTE 320 /* Invalid Attribute Line: */
#define INVALID_FORMAT 321 /* Invalid Format Line: */
#define MISSING_REQ_ATTRIB 322 /* Required Attribute Missing Name: */
#define MISSING_REL_OBJECT 323 /* Required Related Object Missing Name: */
#define NON_UNIQ_KEY 324 /* Primary Key Not Unique */
#define EXCEEDED_MAXREC 330 /* Exceeded Max Records Limit */
#define INVALID_MAXREC 331 /* Invalid Max Records Size */
#define NO_TRANSFER 332 /* Nothing To Transfer */
#define NO_SOA 333 /* Not SOA for Requested Authority Area */
#define UNIMPLEM_DIRECTIVE 334 /* Pre-query Directive Not Implemented */
#define UNAVAIL_SYSLOAD 335 /* Systems Load Not Available */
#define NO_OBJECT_FOUND 336 /* Object Not Found */
#define NO_OBJECT_SCHEMA_FOUND 337 /* No Format Found for Object */
#define INVALID_DIRECTIVE_PARAM 338 /* Invalid Directive Parameter */
#define INVALID_DIRECTIVE 400 /* Invalid Server Directive */
#define UNAUTH_DIRECTIVE 401 /* Not Authorized for Directive */
#define UNIDENT_ERROR 402 /* Unidentified Error .. Continue */
#define UNAUTH_REGIST 420 /* Registration Not Authorized */
#define UNAUTH_REGIST_RECORD 421 /* Not Authorized to Change Object */
#define UNAUTH_TO_FRWD 431 /* Not Authorized To Forward */
#define UNAUTH_TO_XFER 432 /* Not Authorized To Transfer */
#define BAD_REF_ON_FRWD 433 /* Bad Reference On Forward */
#define NON_EXIST_REFER 434 /* Referral Does Not Exist on this Server */
#define UNDEF_DEFINE 435 /* Macro not Defined */
#define UNAUTH_DISPLAY 436 /* Display Mode Not Allowed */
#define UNSUPPORT_LANG 437 /* Language Not Supported */
#define UNKNOWN_X_DIRECTIVE 460 /* Extended Directive Not Recognized */
#define UNAUTH_X_DIRECTIVE 461 /* Extended Directive Not Authorized */
#define MEMORY_ALLOCATION_PROBLEM 500 /* Memory Allocation Problem */
#define SERVICE_NOT_AVAIL 501 /* Service Not Available */
#define UNRECOV_ERROR 502 /* Unrecoverable Error... Goodbye */
#define DEADMAN_TIME 503 /* Idle Time Exceeded... Goodbye */
#define UNAUTH_SECONDARY 530 /* Not Authorized As Secondary */
#define MISC_DIAG 560  
