/* RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and that
no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net

File: waitresult.c  processes interaction with server
Developed by: Scott Williamson

*/


#include "rwhois.h"
#include "error.h"


#ifndef __STDC__
/*
 * Find the first occurrence of find in s. (Standard C routine)
 */
char *
strstr(s,find)
char *s;
char *find;
{
        register char c,
          sc;
        register int len;

        if ((c = *find++) != NullCH) {
                len = strlen(find);
                do {
                        do {
                                if ((sc = *s++) == NullCH)
                                        return (NULL);
                        } while (sc != c);
                } while (strncmp(s, find, len) != 0);
                s--;
        }
        return ((char *) s);
}
#endif

int
wait_result( waittime)
int waittime;
{
int fret;
char retline[MAXBUFFER];
int maxwait = 0;
struct SERVER *this_server;
char outbuffer[MAXBUFFER];
char *ptr;
char version[80];
char location[80];
int ret = WAIT_NULL;

	this_server = SERVERCURRGET;

	/* clean out the buffer */
	retline[0] = '\n';

	/* read back results */
	while( ret != WAIT_OK && ret != WAIT_ERROR && ret != WAIT_IDYES
		&& ret != WAIT_IDNO && ret != WAIT_REFERRAL && ret != WAIT_SEEALSO
		&& ret != WAIT_EDIT  && ret != WAIT_CONTINUE 
		&& ((fret = fdata(retline, MAXBUFFER, this_server->sh, waittime)) != 0))
		{

#ifdef DEBUG
printf("\n[%s] && ret = %d type = %d", retline, ret, this_server->type_status);
fflush(stdout);
#endif

		if( fret == TIMEOUT 
			&& !( this_server->type_status 
				& (TYPE_RWHOIS|STATUS_QUERYSENT)))
		{
			if( verbose > TALK )
			{
				printf("\nServer does not appear to be an RWHois server");
				if( edit != ON)	
					printf("\nSending query .... [%s]\n", 
						this_server->query );
				else
				{
					printf("\nCan't do edit action with NON-RWhois server");
					return(WAIT_ERROR);
				}
			}

			if(this_server->query)
				sprintf( outbuffer, "%s\r\n", this_server->query);
			else
				sprintf( outbuffer, "\r\n");

			if((*outbuffer == '\r' || *outbuffer == NullCH) && forcing )
				strcpy( outbuffer, "-QUIT");

	 		write( this_server->sh, outbuffer, strlen( outbuffer));
				this_server->type_status =
				this_server->type_status|STATUS_QUERYSENT; 
				
		}
		else if( fret == TIMEOUT && ( (maxwait += waittime) > default_maxwait))
		{
			if( verbose > WHISPER)
				printf("\nWait of more than %d seconds with no activity... Quit"					, maxwait);
	/*		if( this_server->type_status&TYPE_RWHOIS)
				send_command("-QUIT"); */
			return( WAIT_ERROR);

		}
		else if( fret == TIMEOUT && punt_referral == TRUE )
		{
			if( verbose > WHISPER )
				note("Received punt referral from old server... will move on.");
			return( WAIT_REFERRAL);
		/*	if( this_server->type_status&TYPE_RWHOIS)
				send_command("-QUIT"); */
		}

			

		/* first determine that it is an RWhois server */

		if(!strncmp( retline, "%RWhois", 7))
		{


			ptr = ( char *) strstr( retline, "V-");
			if( sscanf( ptr, "%s %s", version, location))
			{
				if( verbose )
					printf("\nRWhois Server at %s version %s\n", 
							location, version);
			}
			else
				if( verbose )
			 	  printf("\nRWhois Server ... can't id version will continue");

			sprintf( outbuffer, "RWhois V-%s (InterNIC V-%s)", 
				SPEC_VERSION, IMP_VERSION);
			send_command( outbuffer);
			control_pannel[CP_PROMPT] = SET_WAIT;


			if(!(this_server->type_status&TYPE_RWHOIS))
			{
				this_server->type_status = TYPE_RWHOIS;
				server_main( SER_MODIFY, this_server );
			}

		}

		/* This will catch Bunyip whois++ server */
		/* must change to catch all whois++ severs */
		else if(!strncmp( retline, "% 200", 5))
		{

			if( verbose > WHISPER )
				printf("\nSeems to be a Bunyip whois++ server");
			
			if(!(this_server->type_status&TYPE_WHOISPLUSPLUS))
			{
				this_server->type_status = TYPE_WHOISPLUSPLUS; 
				server_main( SER_MODIFY, this_server);
			}
			
			ret = WAIT_IDNO;
			
		}

		/* only allow commands once RWhois server for sure */
		else if(retline[0] == '%' && ((this_server->type_status &TYPE_RWHOIS)))
		{
			
			ret = pre_response( retline);

		}
		else 
		{
			if( to_file )
				wkfile_write( this_server, retline);
			else
				printf("%s", retline);

		}
	}

	if( fret == -1 )
		ret = WAIT_NO;

	return( ret);
}

