#include <stdio.h>
#include <string.h>
#include "defines.h"
#include "attributes.h"
#include "objects.h"
#include "rwhois_supp.h"

attribute_struct *set_attributes_list_from_object ();

static attribute_struct *prev_attrib = NULL;


/****************************************************************************
  resets the object for the next type
  Mark Kosters/InterNIC (markk@internic.net)
****************************************************************************/
reset_object()
{
}

/****************************************************************************
  sets the object for the type
  Mark Kosters/InterNIC (markk@internic.net)
****************************************************************************/
attribute_struct *get_attribute_info (line, datum, filename, line_no)
char *line;
char *datum;
char *filename;
int line_no;

{
char object_name[MAX_LINE];
char attribute_name[MAX_LINE];

attribute_struct *attrib;

if(!get_tuple (object_name, attribute_name, datum, line)) {
  if (prev_attrib != NULL)
    return (prev_attrib);
  else {
    print_error (999, "error(%s:%d): \"%s\"", filename, line_no, line);
    return (NULL);
    }
  }
attrib = get_attribute_info_from_name_and_object (object_name, attribute_name);

   /*
    * we didn't find a corresponding attribute in the configuration file so
    * just continue as if nothing had happened
    */

if (attrib == NULL) {
printf ("no the real problem is here -have |%s| |%s|!\n", object_name,
  attribute_name);
  print_error (999, "error(%s:%d): \"%s\"", filename, line_no, line);
  return (NULL);
  }
prev_attrib = attrib;
return (attrib);
}

/****************************************************************************
  sets the object for the type
  Mark Kosters/InterNIC (markk@internic.net)
  Returns TRUE if to index this
          FALSE if not
****************************************************************************/
set_index_format (object_name, attribute_name, line, datum, pass)
char *object_name;
char *attribute_name;
char *line;
char *datum;
int pass;

{
int index_field, retval = FALSE;
attribute_struct *attrib;
*line = '\0';

attrib = get_attribute_info_from_name_and_object (object_name, attribute_name);
/* if we can't find attribute info for this object, we can't index it. */
if (!attrib) {
    return (FALSE);
}

/***
  do special things based on the attribute type
***/

switch  (attrib->type) {
   case TYPE_TEXT:
     index_field = TRUE;
     break;
   case TYPE_FILE:
     index_field = FALSE;
     break;
   case TYPE_MIME:
     index_field = FALSE;
     break;
   case TYPE_SEE_ALSO:
/* parse_line (datum, tmp_str2, datum); */
     index_field = TRUE;
     break;
  }
if (index_field) {
  switch  (attrib->index_words) {
    case INDEX_ALL_WORDS:
    case INDEX_FIRST_WORD:
      Ltrim (datum);
      if (pass == 0) {
        sprintf (line, "%d%s%s", attrib->global_id, INDEX_PRFX, datum);
        strupr (line);
        retval = TRUE;
        }
      else if (pass == 1) {
        strupr (strcpy (line, datum));
        retval = TRUE;
        }
      else
        retval = FALSE;
      break;
  case INDEX_WORD_ONLY:
    Ltrim (datum);
    if (pass == 0) {
      sprintf (line, "%d%s%s", attrib->global_id, INDEX_PRFX,datum);
      strupr (line);
      retval = TRUE;
      }
    else
      retval = FALSE;
    break;
  case INDEX_NO_WORDS:
      retval = FALSE;
      break;
    }
  return (retval);
  }
else
  return (FALSE);
}
/****************************************************************************
  resets the object for the next type
  Mark Kosters/InterNIC (markk@internic.net)
****************************************************************************/
reset_object_old()
{
set_attributes_list_from_object (FALSE, NULL, NULL);
prev_attrib = NULL;
}

/****************************************************************************
  sets the object for the type
  Mark Kosters/InterNIC (markk@internic.net)
****************************************************************************/
attribute_struct *get_attribute_info_old (line, datum, filename, line_no)
char *line;
char *datum;
char *filename;
int line_no;

{
char tag[2048];

attribute_struct *cur_attrib, *attrib;

if(parse_line(line,tag,datum) != 1){
  if (prev_attrib != NULL)
    return (prev_attrib);
  else {
    print_error (999, "error(%s:%d): \"%s\"", filename, line_no, line);
    return (NULL);
    }
  }
attrib = set_attributes_list_from_object (TRUE, tag, datum);
while (attrib != NULL) {
  if(strcasecmp(tag, attrib->name) == 0 || 
    (attrib->name_alias != NULL && strcasecmp (tag, attrib->name_alias) == 0)){
    cur_attrib = attrib;
    break;
    }
  attrib = attrib->nxt;
  }

   /*
    * we didn't find a corresponding attribute in the configuration file so
    * just continue as if nothing had happened
    */

if (attrib == NULL) { 
  print_error (999, "error(%s:%d): \"%s\"", filename, line_no, line);
  return (NULL);
  }
prev_attrib = cur_attrib;
return (cur_attrib);
}
