/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#include <stdio.h>
#include "defines.h"
#include "misc.h"
#include "llist.h"
#include "client_info.h"

/***************
  local prototypes
***************/
static char implement_id[MAX_LINE] = "";
static char spec_version[MAX_LINE] = "";
static llist_struct *capabilities = NULL;

/****************************************************************************
  gets the version number of the client
****************************************************************************/
int set_client_info (str)
char *str;

{
char *next;
set_passthru();
next = get_word (str, spec_version);
if (next != NULL)
  strcpy (implement_id, next);
print_ok();
}

/****************************************************************************
  shows the client version
****************************************************************************/
char *show_client_info()

{
if (strlen (spec_version))
  return (spec_version);
else
  return ("[unknown]");
}
/****************************************************************************
  sets the client capabilites
****************************************************************************/
int set_client_capabilities (mode)
char *mode;

{
if (strlen (mode)>0)
  capabilities = append_llist (capabilities, mode);
}

/****************************************************************************
  checks the client capabilites
  returns TRUE if ok
          FALSE if not
****************************************************************************/
int check_capabilities (mode)
char *mode;

{
llist_struct *cur = capabilities;

while (cur != NULL) {
  if (strcasecmp (mode, cur->datum) == 0)
    return (TRUE);
  cur = cur->nxt;
  }
return (FALSE);
}

/****************************************************************************
  This is a matrix if the client is capable of doing the action
  return TRUE if is ok
         FALSE otherwise
****************************************************************************/
int is_client_capable_of_action (action)
char *action;

{
#if DEBUG
printf ("is_client_capable_of_action: version |%s|\n", spec_version);
printf ("is_client_capable_of_action: ipml id |%s|\n", implement_id);
printf ("is_client_capable_of_action: action |%s|\n", action);
#endif
return (TRUE);
}
