/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/

#include <stdio.h>
#include <string.h>
#include "defines.h"
#include "client_msgs.h"
#include "define.h"

/****
  prototypes 
*****/

static d_type get_define_type();

/****
  globals
*****/

static define_struct *define_list = NULL;

/****************************************************************************
 reads the defines from a file
****************************************************************************/
read_define_file (file)
char *file;

{
FILE *fp;
char line[MAX_LINE];
char tag[MAX_LINE];
char datum[MAX_LINE];
int type;
define_struct *new, *cur;

if (strlen(file) == 0) {
  return (TRUE);
  }

if((fp = fopen(file, "r")) == (FILE *) NULL){
  return(FALSE);
  }

while ((fgets (line, BUFSIZ, fp)) != NULL) {
  if (new_record (line) || define_list == NULL) {
    new = NEW_DEFINE;
    if (define_list == NULL)
      define_list = cur = new;
    else {
      cur->nxt = new;
      cur = new;
      }
    }
  if (parse_line (line, tag, datum)) {
    if (strcasecmp (tag, D_TYPE) == 0)
      cur->type = get_define_type (datum);
    else if (strcasecmp (tag, D_NAME) == 0)
      cur->name = NEW_STRING (datum);
    else if (strcasecmp (tag, D_VALUE) == 0)
      cur->value = NEW_STRING(datum);
    }
  }
return (TRUE);
}

/****************************************************************************
 returns the define type
****************************************************************************/
static d_type get_define_type (type)
char *type;

{
if (strcasecmp (type, D_DEFINE_MACRO) == 0)
  return (DEFINE_MACRO);
}

/****************************************************************************
 displays the define
****************************************************************************/
display_define (str)
char *str;

{
define_struct *cur = define_list;
int found = FALSE;

set_passthru();
while (cur != NULL) {
  if (strlen(str) == 0 || strcasecmp (cur->name, str) == 0) {
    printf ("%%define %s:[%s]\n", cur->name, cur->value);
    found = TRUE;
    }
  cur = cur->nxt;
  }
if (!found)
  print_error (UNDEF_DEFINE, "");
else
  print_ok();
return (FALSE);
}
