/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#ifndef _DISPLAYS_H_
#define _DISPLAYS_H_

#include "output.h"

/*******
  tags for parsing definitions
*******/

#define O_COMMAND        "command"
#define O_COMMAND_LEN    "command-len"
#define O_MAGIC          "magic"
#define O_DESCRIPTION    "description"
#define O_HEADER         "header"
#define O_FOOTER         "footer"
#define O_RECORD_DELIM   "record-delim"
#define O_DEFAULT_MULTI  "default-multi"
#define O_DEFAULT_SINGLE "default-single"


typedef struct _output_command_struct {
  char *command;
  int command_len;
  char *magic;
  char *description;
  char *header;
  char *footer;
  char *record_delim;
  struct _output_command_struct *nxt;
  } output_command_struct;

#define NEW_OUTPUT_COMMAND (output_command_struct *) calloc ((unsigned)1, \
   (unsigned)sizeof(output_command_struct))

typedef struct _output_display_struct {
  char *command;
  int command_len;
  char *filename;
  output_format_struct *format;
  struct _output_display_struct *nxt;
  } output_display_struct;

#define NEW_OUTPUT_DISPLAY (output_display_struct *) calloc ((unsigned)1, \
   (unsigned)sizeof(output_display_struct))

/*******
  prototypes
*******/

output_display_struct *read_display_format_from_object();
output_command_struct *return_all_defined_displays();
char *get_display_status();
#endif
