/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#include <stdio.h>
#include "defines.h"
#include "client_msgs.h"
#include "holdconnect.h"

static int holdconnect = FALSE, pass_thru=FALSE;
static char root_rwhois_dir[MAX_LINE];

/**************************************************************************
  sets the holdconnect value
   toggles it for now
**************************************************************************/
int set_holdconnect(str)
char *str;

{
trim (str);
if (strcasecmp(str, "ON") == 0) {
  holdconnect=TRUE;
  print_ok();
  }
else if (strcasecmp (str, "OFF") == 0) {
  holdconnect=FALSE;
  print_ok();
  }
else 
  print_error (INVALID_DIRECTIVE_PARAM, "");
set_passthru();
return(0);
}

/**************************************************************************
  sets pass thru on (for directive commands)
**************************************************************************/
int set_passthru ()

{
pass_thru = TRUE;
}


/**************************************************************************
  forces the hold connect off
  -gives no ack
**************************************************************************/
int force_holdconnect_off()

{
pass_thru=FALSE;
holdconnect=FALSE;
return(0);
}

/**************************************************************************
  returns the holdconnect value
**************************************************************************/
int holdconnect_status()

{
if (pass_thru) {
  pass_thru = FALSE;
  return (TRUE);
  }
return (holdconnect);
}

/*************************************************************************
  sets the directory to work from
**************************************************************************/
set_root_dir (default_dir)
char *default_dir;

{
if (chdir (default_dir) == -1) {
  printf ("default directory \"%s\" does not exist - exiting\n", default_dir);
  exit(1);
  }
strcpy (root_rwhois_dir, default_dir);
}

/*************************************************************************
  sets the directory to work from
**************************************************************************/
char *get_root_dir()

{
return (root_rwhois_dir);
}

