/************************************************************************
RWhois Software 

Copyright (c) 1994 Scott Williamson and Mark Kosters

Users may distribute the binary and source code to third parties provided
that the copyright notice and this statement appears on all copies and 
that no charge is made for such copies.  

This software is provided AS IS with no warranties of any kind.  The authors
shall have no liability with respect to the infringement of copyrights,
trade secrets or any patents by this file or any part thereof.  In no
event will the authors be liable for any lost revenue or profits or
other special, indirect and consequential damages.

Comments and additions should be sent to the authors:

                    Scott Williamson
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4820
					scottw@internic.net

                    Mark Kosters
                    Network Solutions
                    505 Huntmar Park Drive
                    Herndon, VA 22071
                    (703) 742-4795
					markk@internic.net


Developed By: 
  Mark Kosters
***************************************************************************/
#include <stdio.h>
#include <signal.h>
#include <sgtty.h>
#include "defines.h"
#include "interrupts.h"
#include "client_msgs.h"
#include "commands.h"

/******
 these are needed for the static commands
*******/
#include "help.h"
#include "exit.h"

/***********
  global things 
***********/
static struct tchars old_tch;

/*************************************************************************
  initialize enviroment - sets up linked lists
  returns TRUE if okay
          FALSE otherwise
**************************************************************************/
initialize_environment(config_file, in_jail)
char *config_file;
int in_jail;

{
char display_file[MAX_LINE];
char directive_file[MAX_LINE];
char define_file[MAX_LINE];
char object_file[MAX_LINE];

initialize_signals();
initialize_command_list();
initialize_directive_list();
return (read_config_files (config_file, in_jail));
}

/*************************************************************************
  sets the hacker signals
**************************************************************************/
initialize_signals()

{
struct tchars tch;

ioctl(0, TIOCGETC, &old_tch);         /* get current stuff */
ioctl(0, TIOCGETC, &tch);         /* get current stuff */
/* tch.t_quitc = ABORT_CHAR;         /* make quit char ^G */
/* tch.t_intrc = STATUS_CHAR;        /* make int char ^E */
/* ioctl(0, TIOCSETC, &tch);         /* set it back now */
/* signal(SIGQUIT, int_abort);*/       /* go here on abort */
/*signal(SIGINT, int_status);*/       /* here for status */
signal(SIGKILL, int_exit);        /* here for exit */
signal(SIGTERM, int_exit);        /* here for exit */
signal(SIGPIPE, int_exit);        /* here for exit */
}


/****************************************************************************
 initializes the internal commands
****************************************************************************/

initialize_command_list()
{
/*
append_command ("dump", 4, "#", TRUE, COMMAND_DISPLAY, NULL, NULL, NULL);
*/
append_command (NULL, 0, "!", "handle query", TRUE, COMMAND_QUERY, NULL, 
  NULL, NULL);
append_command ("help", 4, NULL, "display help text", FALSE, 
  COMMAND_SPECIAL, NULL, help, NULL);
append_command ("quit", 4, NULL, "exit rwhois", FALSE, COMMAND_SPECIAL, NULL,
  exit_whois, NULL);
append_command ("exit", 4, NULL, "exit rwhois", FALSE, COMMAND_SPECIAL, NULL,
  exit_whois, NULL);
}

/*************************************************************************
  resets signals to normal (for command line testing)
**************************************************************************/
reset_signals ()
{
ioctl(0, TIOCSETC, &old_tch);
}
