 /*
  * refuse() reports a refused connection, and takes the consequences: in
  * case of a datagram-oriented service, the unread datagram is taken from
  * the input queue (or inetd would see the same datagram again and again);
  * the program is terminated.
  * 
  * Author: Wietse Venema, Eindhoven University of Technology, The Netherlands.
  */

#ifndef lint
static char sccsid[] = "@(#) refuse.c 1.2 92/06/11 22:21:34";
#endif

/* new stuff MK */
#include <stdio.h>
#define MAX_HOST_SIZE 64
/* end of new stuff MK */

/* System libraries. */

#include <syslog.h>

/* Local stuff. */

#include "log_tcp.h"

/* refuse - refuse request from bad host */

void    refuse(client)
struct from_host *client;
{
/* new stuff MK */
char hname[MAX_HOST_SIZE+1];
char dname[MAX_HOST_SIZE+1];
gethostname (hname, MAX_HOST_SIZE);
if (strchr (hname, '.') == NULL)
  {
  getdomainname (dname, MAX_HOST_SIZE); 
  strcat (hname, ".");
  strcat (hname, dname);
  }
/* end of new stuff MK */
  printf ("Access is denied on %s and your attempt has been logged!!\n",
    hname);
    syslog(LOG_WARNING, "refused connect from %s", hosts_info(client));
    clean_exit(client);
    /* NOTREACHED */
}
